"use strict";

function logMessage(str) {
    document.body.appendChild(document.createTextNode(str));
    document.body.appendChild(document.createElement("br"));
}

function addButton(text, onclick) {
    let but = document.createElement("button");
    but.textContent = text;
    but.onclick = async () => {
        try {
            let result = await onclick();
            logMessage(`[result] ${text} = ${result}`);
        } catch (e) {
            logMessage(`[error] ${text} = ${e}`);
        }

    };
    document.body.appendChild(but);
    document.body.appendChild(document.createElement("br"));
}

for (let perm of [
    {origins: ["<all_urls>"]},
    {permissions: ["tabs"]},
]) {
    addButton(`permissions.request(${JSON.stringify(perm)})`, async () => {
        return await browser.permissions.request(perm);
    });

    addButton(`permissions.contains(${JSON.stringify(perm)})`, async () => {
        return await browser.permissions.contains(perm);
    });

    addButton(`permissions.remove(${JSON.stringify(perm)})`, async () => {
        return await browser.permissions.remove(perm);
    });

    document.body.appendChild(document.createElement("br"));
}
